import { useEffect, useState } from "react";

const concurrencyRequest = (urls, maxNum) => {
  return new Promise((resolve) => {

    if (urls.length === 0) {
      resolve([]);
      return;
    }
    const results = [];
    let index = 0;
    let count = 0;

    async function request() {
      if (index === urls.length) return;
      const i = index;
      const url = urls[index];
      index++;
      // 1：处理error，要在用await的地方处理
      try {
        const response = await fetch(url);
        const resp = await response.json();
        results[i] = resp;
      } catch (err) {
        results[i] = err;
      } finally {
        count++;
        if (count === urls.length) {
          console.log("finish");
          resolve(results);
        }
        // sequence parallel
        request();
      }
    }
    const timers = Math.min(maxNum, urls.length);
    for (let i = 0; i < timers; i++) {
      // 并发的request --- parallel,注意error的处理--建1
      console.log('r2', i)
      request();
    }
  })
}

function urlGen() {
  let urls = [];
  for (let i = 0; i < 100; i++) {
    urls.push(`http://jsonplaceholder.typicode.com/posts/${i}`)
  }
  return urls;
}
const allRequests = urlGen();

function Comments() {
  // learning parallel request with limite
  const [post, setPost] = useState([]);
  useEffect(() => {
    async function concurrentFetch() {
      const response = await concurrencyRequest(allRequests, 10);
      console.log(response)
    }
    concurrentFetch();
  }, [])

  return (
    <div>
      <h1>Post</h1>
      <p>{ post.id }</p>
    </div>
  );
}

export default Comments;