export const getStaticPaths = async() => {
  // generate all the routes for the static page
  // how many htmls files we need
  const res = await fetch('https://jsonplaceholder.typicode.com/users');
  const data = await res.json();
 
  const paths = data.map(user=>({
    params: {id:user.id.toString()}
  }))
  return {
    paths,
    fallback:false
  }
}

export const getStaticProps = async(context) => {
  const id = context.params.id;
  const res = await fetch(`https://jsonplaceholder.typicode.com/users/${id}`);
  const data =await res.json();
  return {
    props: {
      user:data
    }
  }
}

// dynamic router
function UserDetail({user}) {
  return ( 
    <div>
      <h1>User detail</h1>
      <div>{user.name}</div>
      <div>{user.email}</div>
    </div>
   );
}

export default UserDetail;