import style from '../../styles/users.module.css';
import Link from 'next/link';
// run at build time not in the browser
// how to fetch data in next js
export const getStaticProps = async()=>{
  const response = await fetch('https://jsonplaceholder.typicode.com/users');
  const data = await response.json();
  return {
    // pass as props to component
    props: {
      users: data
    }
  }
}

function Users({users}) {
  return ( 
    <div>
      <h1>All users</h1>
      {
        users.map((u)=>(
          <Link href={`/users/${u.id}`} key={u.id}>
           {u.name}
          </Link>
        ))
      }
    </div>
   );
}

export default Users;